【CF613D】Kingdom and its Cities

题目

题目链接:https://codeforces.com/problemset/problem/613/D
一个王国有 \(n\) 座城市,城市之间由 \(n-1\) 条道路相连,形成一个树结构,国王决定将一些城市设为重要城市。
这个国家有的时候会遭受外敌入侵,重要城市由于加强了防护,一定不会被占领。而非重要城市一旦被占领,这座城市就不能通行。
国王定了若干选择重要城市的计划,他想知道,对于每个计划,外敌至少要占领多少个非重要城市,才会导致重要城市之间两两不连通。如果外敌无论如何都不可能导致这种局面,输出-1。
\(1\leq n,q,\sum^{q}_{i=1}m_i\leq 10^5\)

思路

先考虑只有一个询问怎么做。首先很明显的一点是,输出 -1 的充要条件是存在两个重要节点相邻。
排除这种情况后,剩余的就是有解的。
设 \(cnt_x\) 表示 \(x\) 的子树中没有被截断的(与 \(x\) 通过若干条边相连的)点有多少个。注意不包括 \(x\) 本身。
那么

  • 如果 \(key[x]=1\),那么对于这 \(cnt_x\) 个点都要割掉一条边,\(ans\) 加上 \(cnt_x\)。
  • 如果 \(key[x]=0\),那么
    • 如果 \(cnt[x]=1\),那么现在没必要割,显然留到后面割肯定更优。
    • 如果 \(cnt[x]>1\),那么必须割掉 \(x\),\(ans\) 加一。

这样就可以在 \(O(n)\) 的复杂度内解决这个问题。
但是现在有多组询问,我们发现 \(\sum m\leq 10^5\),而每次询问我们只需要知道关键节点之间的信息,所以构建虚树即可。
时间复杂度 \(O(n\log n)\)。

代码

#include <set>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const int N=100010,LG=20;
int n,m,Q,tot,top,ans,a[N],dfn[N],head[N],st[N],f[N][LG+1],dep[N];
bool flag,key[N];
set<int> vis;

struct edge
{
    int next,to;
}e[N*2];

void add(int from,int to)
{
    e[++tot].to=to;
    e[tot].next=head[from];
    head[from]=tot;
    if (vis.find(from)==vis.end()) vis.insert(from);
    if (vis.find(to)==vis.end()) vis.insert(to);
}

bool cmp(int x,int y)
{
    return dfn[x]<dfn[y];
}

void dfs(int x,int fa)
{
    dfn[x]=++tot;
    f[x][0]=fa; dep[x]=dep[fa]+1;
    for (int i=1;i<=LG;i++)
        f[x][i]=f[f[x][i-1]][i-1];
    for (int i=head[x];~i;i=e[i].next)
        if (e[i].to!=fa) dfs(e[i].to,x);
}

int lca(int x,int y)
{
    if (dep[x]<dep[y]) swap(x,y);
    for (int i=LG;i>=0;i--)
        if (dep[f[x][i]]>=dep[y]) x=f[x][i];
    if (x==y) return x;
    for (int i=LG;i>=0;i--)
        if (f[x][i]!=f[y][i])
            x=f[x][i],y=f[y][i];
    return f[x][0];
}

bool build()
{
    st[++top]=0;
    sort(a+1,a+1+m,cmp);
    for (int i=1;i<=m;i++)
    {
        int p=lca(a[i],st[top]);
        if (p!=st[top])
        {
            while (dep[st[top-1]]>dep[p])
            {
                add(st[top-1],st[top]);
                top--;
            }
            add(p,st[top]); top--;
            if (st[top]!=p) st[++top]=p;
        }
        st[++top]=a[i];
    }
    for (int i=top;i>=2;i--)
        add(st[i-1],st[i]);
}

int dfs2(int x)
{
    int cnt=0;
    for (int i=head[x];~i;i=e[i].next)
    {
        int v=e[i].to;
        cnt+=dfs2(v);
        if (key[v] && key[x] && dep[v]==dep[x]+1) flag=1;
        if (flag) return -1;
    }
    if (key[x]) ans+=cnt,cnt=1;
        else if (cnt>1) ans++,cnt=0;
    return cnt;
}

int main()
{
    memset(head,-1,sizeof(head));
    scanf("%d",&n);
    for (int i=1,x,y;i<n;i++)
    {
        scanf("%d%d",&x,&y);
        add(x,y); add(y,x);
    }
    tot=0; dfs(1,0);
    memset(head,-1,sizeof(head));
    tot=0;
    scanf("%d",&Q);
    while (Q--)
    {
        scanf("%d",&m);
        for (int i=1;i<=m;i++)
        {
            scanf("%d",&a[i]);
            key[a[i]]=1;
        }
        build();
        dfs2(0);
        if (flag) printf("-1\n");
            else printf("%d\n",ans);
        for (set<int>::iterator it=vis.begin();it!=vis.end();it++)
            head[*it]=-1,key[*it]=0;
        vis.clear();
        flag=tot=ans=top=0;
    }
    return 0;
}

原文地址:https://www.cnblogs.com/stoorz/p/12405605.html

时间: 2024-11-10 05:10:18

【CF613D】Kingdom and its Cities的相关文章

HDU1025_Constructing Roads In JGShining&#39;s Kingdom【LIS】【二分法】

Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 16590    Accepted Submission(s): 4722 Problem Description JGShining's kingdom consists of 2n(n is no mo

【HDU3371】Connect the Cities(MST基础题)

注意输入的数据分别是做什么的就好.还有,以下代码用C++交可以过,而且是500+ms,但是用g++就会TLE,很奇怪. 1 #include <iostream> 2 #include <cstring> 3 #include <cstdio> 4 #include <cstdlib> 5 #include <cmath> 6 #include <cctype> 7 #include <algorithm> 8 #incl

【CF687D】Dividing Kingdom II 线段树+并查集

[CF687D]Dividing Kingdom II 题意:给你一张n个点m条边的无向图,边有边权$w_i$.有q个询问,每次给出l r,问你:如果只保留编号在[l,r]中的边,你需要将所有点分成两个集合,使得这个划分的代价最小,问最小代价是什么.一个划分的代价是指,对于所有两端点在同一集合中的边,这些边的边权最大值.如果没有端点在同一集合中的边,则输出-1. $n,q\le 1000,m\le \frac {n(n-1)} 2,w_i\le 10^9$ 题解:先考虑暴力的做法,我们将所有边按

HDU4081 Qin Shi Huang&#39;s National Road System【Kruska】【次小生成树】

Qin Shi Huang's National Road System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 3979    Accepted Submission(s): 1372 Problem Description During the Warring States Period of ancient China(4

【最小生成树】UVA1494Qin Shi Huang&#39;s National Road System秦始皇修路

Description During the Warring States Period of ancient China(476 BC to 221 BC), there were seven kingdoms in China -- they were Qi, Chu, Yan, Han, Zhao, Wei and Qin. Ying Zheng was the king of the kingdom Qin. Through 9 years of wars, he finally con

HDU1385 Minimum Transport Cost 【Floyd】+【路径记录】

Minimum Transport Cost Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7496    Accepted Submission(s): 1918 Problem Description These are N cities in Spring country. Between each pair of cities

NYOJ 587 blockhouses 【DFS】

blockhouses 时间限制:1000 ms  |  内存限制:65535 KB 难度:3 描述 Suppose that we have a square city with straight streets. A map of a city is a square board with n rows and n columns, each representing a street or a piece of wall. A blockhouse is a small castle th

我的Android进阶之旅------&gt;Android【设置】-【语言和输入法】-【语言】列表中找到相应语言所对应的列表项

今天接到一个波兰的客户说有个APP在英文状态下一切运行正常,但是当系统语言切换到波兰语言的时候,程序奔溃了.所以首先我得把系统的语言切换到波兰语,问题是哪个是波兰语呢? 我还真的不认识哪个列表项代表着波兰语.如下图所示:进入到[设置]-[语言和输入法]-[语言]列表后,我就傻眼了,哪个是波兰语呢?本文将介绍如何在列表中找到相应语言所对应的列表项. ([Settings]-[Language & input]-[Language]) 哪个是波兰语呢?好吧,我只认识 日本语.中文.英语的几项,其他的

hdu 4004 The Frog&#39;s Games【二分】

The Frog's Games Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others) Total Submission(s): 3980    Accepted Submission(s): 1931 Problem Description The annual Games in frogs' kingdom started again. The most famous game